#include "stdafx.h"
#include "RedAverage.h"



void RMerge::ProcessPlane(int plane, IScriptEnvironment* env)
{
	_declspec(align(16)) int pitches[8];
	_declspec(align(16)) unsigned char* frameptrs[8];

	for (int i=0;i<3;++i){
		pitches[(i+1)*2] = frames[i]->GetPitch(plane);
		pitches[(i+1)*2+1] = frames[i]->GetPitch(plane);
	}
	pitches[0] = result->GetPitch(plane);
	pitches[1] = result->GetPitch(plane);

	const int src_width=frames[0]->GetRowSize(plane);
	const int dst_width=result->GetRowSize(plane);
	const int width=src_width;
	const int src_height=frames[0]->GetHeight(plane);
	const int dst_height=result->GetHeight(plane);
	const int s_height=(lsb_in ? src_height/2 : src_height );
	const int d_height=(lsb_out? dst_height/2 : dst_height );

	for (int i=0;i<3;++i) {
		frameptrs[(i+1)*2] = (unsigned char*) frames[i]->GetReadPtr(plane);
 		frameptrs[(i+1)*2+1] = frameptrs[(i+1)*2]+pitches[(i+1)*2]*s_height;
	}
	frameptrs[0] = result->GetWritePtr(plane);
	frameptrs[1] = frameptrs[0]+pitches[0]*d_height;



//	unsigned char** sourceptrs=&frameptrs[4];



	bool SuccesfullyDone=false;
	if (optimize & 8) {
		if (lsb==0) {
			#define SSE3_PROC
			#undef LSB_OUT
			#undef LSB_IN
			#include "RM16asmM4.hpp"
			#undef SSE3_PROC
		}
	}
	if (!SuccesfullyDone) {
		#include "RM16cpp.hpp"
	}

}


