#include "CommonFilter.h"

#ifndef _RED_AVERAGE_H_
#define _RED_AVERAGE_H_



const int ScaleM16ASMpower=8;
const int ScaleM8ASMpower=16;
const int ScaleM16CPPpower=16;
const int ScaleM8CPPpower=8;
const int ScaleM16ASM=1<<ScaleM16ASMpower;
const int ScaleM8ASM=1<<ScaleM8ASMpower;
const int ScaleM16CPP=1<<ScaleM16CPPpower;
const int ScaleM8CPP=1<<ScaleM8CPPpower;

const int ScaleWMax=1<<24;



class RMerge : public CommonFilter 
{   
private:
	int mode;
protected:
	void ProcessPlane(int plane, IScriptEnvironment* env);
public:
	RMerge(PClip _child, vector<PClip> _clips, double _bias, int _y, int _u, int _v, int _sse, bool _lsb_in, bool _lsb_out, int mode, IScriptEnvironment *env);
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment *env);
};



class RAverageM : public GenericVideoFilter 
{   
	vector<PVideoFrame> frames;
	vector<PClip> clips;
	PVideoFrame	result;
	double bias;
	int Y, U, V;
	int sse;
	bool lsb_in, lsb_out;
	int maxbit, length, lsb;
	int optimize;//, special;

	void AveragePlaneM16(int plane, IScriptEnvironment* env);
	PVideoFrame WeightedAverageM16(IScriptEnvironment* env, VideoInfo vi);
public:
	RAverageM(PClip _child, vector<PClip> _clips, double _bias, int _y, int _u, int _v, int _sse, bool _lsb_in, bool _lsb_out, IScriptEnvironment *env);
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment *env);
};



class RAverageW : public GenericVideoFilter 
{   
	vector<PVideoFrame> frames;
	vector<WeightedClip> clips;
	vector<PClip> selectedclips;
	vector<int> ScaledWeight; 
	PVideoFrame	result;
	double bias;
	long long ScaledBias;
	int Y, U, V;
	int sse;
	bool lsb_in, lsb_out;
	int maxbit, maxbitsrc, lsb;
	int length;
	int ScaleW_WPower,ScaleW_SWPower,ScaleW_CPower,ScaleW_SBPower; //scales for different methods:pmuluw,pmulsw,nonasm,pmaddubsw
	bool IsSignedW, IsSignedB;
	int optimize;//, special;
	int method;
	bool InvertShift;
	
	int AssessWeights16(int mode, int errlevel, bool silent, IScriptEnvironment* env);
	int CalcError(int scalepower, int lsbcp);
	void AveragePlaneW16(int plane, IScriptEnvironment* env);
	PVideoFrame WeightedAverageW16(IScriptEnvironment* env, VideoInfo vi);
public:
	RAverageW(PClip _child, vector<WeightedClip> _clips, double _bias, int _y, int _u, int _v, int _sse, bool _lsb_in, bool _lsb_out, int _mode, int errlevel, bool _silent, IScriptEnvironment *env);
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment *env);
};



#endif
