#include "stdafx.h"
#include "RedAverage.h"

PVideoFrame RAverageW::WeightedAverageW16(IScriptEnvironment* env, VideoInfo vi)
{
	result = env->NewVideoFrame (vi,PitchAlign);

	if (Y==3) AveragePlaneW16(PLANAR_Y, env);
	if (U==3) AveragePlaneW16(PLANAR_U, env);
	if (V==3) AveragePlaneW16(PLANAR_V, env);

	return (result);
}


void RAverageW::AveragePlaneW16(int plane, IScriptEnvironment* env)
{
	_declspec(align(16)) int pitches[(MaxLen+2)*2];
	_declspec(align(16)) unsigned char* frameptrs[(MaxLen+4)*2];

	for (int i=0;i<length;++i){
		pitches[(i+2)*2] = frames[i]->GetPitch(plane);
		pitches[(i+2)*2+1] = frames[i]->GetPitch(plane);
	}
	pitches[0] = result->GetPitch(plane);
	pitches[1] = result->GetPitch(plane);
	pitches[2] = 0;
	pitches[3] = 0;

	const int src_width=frames[0]->GetRowSize(plane);
	const int dst_width=result->GetRowSize(plane);
	const int width=src_width;
	const int src_height=frames[0]->GetHeight(plane);/////////////////////////////
	const int dst_height=result->GetHeight(plane);
	const int s_height=(lsb_in ? src_height/2 : src_height );
	const int d_height=(lsb_out? dst_height/2 : dst_height );

	for (int i=0;i<length;++i) {
		frameptrs[(i+2)*2] = (unsigned char*) frames[i]->GetReadPtr(plane);
 		frameptrs[(i+2)*2+1] = frameptrs[(i+2)*2]+pitches[(i+2)*2]*s_height;
	}
	frameptrs[0] = result->GetWritePtr(plane);
	frameptrs[1] = frameptrs[0]+pitches[0]*d_height;

	unsigned char** sourceptrs=&frameptrs[4];

	bool SuccesfullyDone=false;
//	if (special==-1) {
//	} else 
	if (method==4) {
		if (optimize & 8) {    //SSE3
			#define SSE3_PROC
			#define SSE2_PROC
			switch (lsb)
			{
			//case 1://16bit in 8bit out
			//	{
			//		#define LSB_IN
			//		#undef LSB_OUT
			//		#include "WAW16asmM4.hpp"
			//		#undef LSB_IN
			//	}
			//	break;
			case 2://8bit in 16bit out
				{
					#undef LSB_IN
					#define LSB_OUT
					#include "WAW16asmM4.hpp"
					#undef LSB_OUT
				}
				break;
			//case 3://16bit in 16bit out
			//	{
			//		#define LSB_IN
			//		#define LSB_OUT
			//		#include "WAW16asmM4.hpp"
			//		#undef LSB_OUT
			//		#undef LSB_IN
			//	}
			//	break;
			case 0://8bit in 8bit out
				{
					#undef LSB_OUT
					#undef LSB_IN
					#include "WAW16asmM4.hpp"
				}
			}
			#undef SSE3_PROC
			#undef SSE2_PROC
		} 
	} else if (method==8) {
		if (optimize & 4) {    //SSE2
			//#define SSE4_PROC
			#define SSE2_PROC
			switch (lsb)
			{
			case 1://16bit in 8bit out
				{
					#define LSB_IN
					#undef LSB_OUT
					#include "WAW16asmM8lsb.hpp"
					#undef LSB_IN
				}
				break;
			case 2://8bit in 16bit out
				{
					#undef LSB_IN
					#define LSB_OUT
					#include "WAW16asmM8.hpp"
					#undef LSB_OUT
				}
				break;
			case 3://16bit in 16bit out
				{
					#define LSB_IN
					#define LSB_OUT
					#include "WAW16asmM8lsb.hpp"
					#undef LSB_OUT
					#undef LSB_IN
				}
				break;
			default://8bit in 8bit out
				{
					#undef LSB_OUT
					#undef LSB_IN
					#include "WAW16asmM8.hpp"
				}
			}
			#undef SSE4_PROC
			#undef SSE2_PROC
		} 
	}

	if (!SuccesfullyDone) {
		#include "WAW16cpp.hpp"
	}
}
